]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Introduce `vcsh setup`
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index daf8893cc0ad617b27b69b3e8e509627c2041361..c05210d2b67e83e0ec43c5972748d747fcc96232 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -5,6 +5,13 @@
 [ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
 
 SELF=$(basename $0)
+if [ "$SELF" = 'bash' ] ||
+   [ "$SELF" = 'dash' ] ||
+   [ "$SELF" = 'sh' ] ||
+   [ "$SELF" = 'zsh' ]; then
+       SELF='vcsh'
+       VCSH_SOURCED=1
+fi
 
 
 help() {
@@ -14,19 +21,20 @@ help() {
          [<repo>]       Clone from an existing repository
    help                 Display this help text
    delete               Delete an existing repository
+   enter                Enter repository; spawn new $SHELL
+   exit                 Exit repository; unset ENV
    init <repo>          Initialize a new repository
-   list                 List all repos
+   list                 List all repositories
    run <repo> \\
        <command>        Use this repository
 
    seed-gitignore \\
    <repo>               Seed .gitignore.d/<repo> from git ls-files
+   setup                Set up repository with recommended settings
+   use <repo>           Use repository; set ENV
 
    <repo> <git command> Special command that allows you to run git commands
                         directly without having to type so much ;)" >&2
-#   use <repo>     Use this repository
-#
-#   exit              Exit vcsh mode" >&2
 }
 
 debug() {
@@ -37,16 +45,12 @@ verbose() {
        if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
-use() {
-       verbose "use() begin"
-       if [ ! -d "$GIT_DIR" ]; then
-               echo E: no repository found for "$VCSH_REPO_NAME" >&2
-               return 1
-       fi
-       export GIT_DIR
-       export GIT_WORK_TREE="$(git config --get core.worktree)"
-       export VCSH_DIRECTORY="$VCSH_REPO_NAME"
-       verbose "use() end"
+setup() {
+       git config core.worktree     "$GIT_WORK_TREE"
+       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+       git config vcsh.vcsh         'true'
+       touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+       git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
 }
 
 init() {
@@ -61,10 +65,7 @@ init() {
                 return 1) || return $?
        cd "$GIT_WORK_TREE"
        git init
-       git config core.worktree     "$GIT_WORK_TREE"
-       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
-       touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
-       git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+       setup
        verbose "init() end"
 }
 
@@ -74,8 +75,21 @@ leave() {
        unset VCSH_DIRECTORY
 }
 
+use() {
+       verbose "use() begin"
+       if [ ! -d "$GIT_DIR" ]; then
+               echo E: no repository found for "$VCSH_REPO_NAME" >&2
+               return 1
+       fi
+       export GIT_DIR
+       export GIT_WORK_TREE="$(git config --get core.worktree)"
+       export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+       verbose "use() end"
+}
+
 
 if [ "$1" = 'clone' ]; then
+       export VCSH_COMMAND="$1"
        GIT_REMOTE="$2"
        export GIT_REMOTE
        VCSH_REPO_NAME="$3"
@@ -83,9 +97,12 @@ if [ "$1" = 'clone' ]; then
        export VCSH_REPO_NAME
        export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
 elif [ "$1" = 'delete' ] ||
+     [ "$1" = 'enter' ] ||
      [ "$1" = 'init' ] ||
      [ "$1" = 'run' ] ||
-     [ "$1" = 'seed-gitignore' ]; then
+     [ "$1" = 'seed-gitignore' ] ||
+     [ "$1" = 'setup' ] ||
+     [ "$1" = 'use' ]; then
        [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
        export VCSH_COMMAND="$1"
        export VCSH_REPO_NAME="$2"
@@ -95,7 +112,8 @@ elif [ "$1" = 'delete' ] ||
        if [ "$VCSH_COMMAND" = 'run' ]; then
                [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
        fi
-elif [ "$1" = 'help' ] ||
+elif [ "$1" = 'exit' ] ||
+     [ "$1" = 'help' ] ||
      [ "$1" = 'list' ]; then
        export VCSH_COMMAND="$1"
 else
@@ -169,16 +187,24 @@ To continue, type \"Yes, do as I say\""
        cd "$old_dir"
        verbose "delete end"
 
-#elif [ "$VCSH_COMMAND" = 'exit' ]; then
-#      verbose "exit begin"
+elif [ "$VCSH_COMMAND" = 'enter' ]; then
+       verbose "enter begin"
+       use || return $?
+       $SHELL
+       leave
+       verbose "enter end"
+
+elif [ "$VCSH_COMMAND" = 'exit' ]; then
+       verbose "exit begin"
 #      if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
 #              unset VCSH_NO_IGNORE_EOF
 #              setopt NO_IGNORE_EOF
 #      fi
-#      leave
+       [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
+       leave
 #      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#      verbose "exit end"
-#      exit 0
+       verbose "exit end"
+       return 0
 
 elif [ "$VCSH_COMMAND" = 'init' ]; then
        verbose "init begin"
@@ -207,7 +233,6 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        # Going back into old directory at the end in case `vcsh use` is reactivated.
        old_dir="$PWD"
        cd "$HOME"
-       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
        gitignores=$(for file in $(git ls-files); do
                while true; do
                        echo $file; new="${file%/*}"
@@ -236,8 +261,15 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        cd "$old_dir"
        verbose "seed-gitignore end"
 
-#elif [ "$VCSH_COMMAND" = 'use' ]; then
-#      verbose "use begin"
+elif [ "$VCSH_COMMAND" = 'setup' ]; then
+       verbose "seed-gitignore begin"
+       use   || return $?
+       setup || return $?
+       leave
+       verbose "seed-gitignore end"
+
+elif [ "$VCSH_COMMAND" = 'use' ]; then
+       verbose "use begin"
 #      if [ -n "$ZSH_VERSION" ]; then
 #              if [ -o NO_IGNORE_EOF ]; then
 #                      export VCSH_NO_IGNORE_EOF=1
@@ -250,9 +282,10 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
 #              zle -N vcsh_exit
 #              bindkey '^d' 'vcsh_exit'
 #      fi
-#      use || return $?
+       [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
+       use || return $?
 #      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#      verbose "use end"
+       verbose "use end"
 
 else
        verbose "defaulting to calling help()"